
#ifndef __TASK_H__
#define __TASK_H__
#ifdef __cplusplus
extern "C" {
#endif


//---------------------------------------------------------------------------
#define TASK_MAX_CNT		100

#define SCR_XH				(240+8)
#define SCR_YH				(160+8)
#define SCR_CX				(SCR_XH<<8)
#define SCR_CY				(SCR_YH<<8)
#define SQR_VX(a, b)		(((long)m_costbl[(a)]            * (b))>>8)
#define SQR_VY(a, b)		(((long)m_costbl[(192+(a))&0xff] * (b))>>8)

#define SPR_MAX_CNT			128
#define SPR_TILENO_MYSHIP	514
#define SPR_TILENO_ENEMY1	516
#define SPR_TILENO_SHOT1	518
#define SPR_TILENO_SHOT2	520

//^XNtF[Y
enum {
	TASK_NONE = 0,
	TASK_INIT,
	TASK_MAIN,
	TASK_USER,
	TASK_END  = 255,
};

//---------------------------------------------------------------------------
//p̂gpŒ菬_
#define X					pos.w.x
#define Y					pos.w.y
#define XH					pos.b.xh
#define YH					pos.b.yh
#define XL					pos.b.xl
#define YL					pos.b.yl
#define MX					mpos.w.x
#define MY					mpos.w.y
#define MXH					mpos.b.xh
#define MYH					mpos.b.yh
                
typedef struct {
	u16 x;
	u16 y;
} ST_FIX_WORD;

typedef struct {
	u8  xl;
	u8  xh;
	u8  yl;
	u8  yh;
} ST_FIX_BYTE;

typedef union {
	ST_FIX_WORD w;
	ST_FIX_BYTE b;
} ST_POS;


//---------------------------------------------------------------------------
//^XÑo
typedef struct {
	bool isUse;				//tO
	u16  phase;				//tF[Y
	u16  no;				//g̃^XNԍ
	void (*pAct)();			//s֐
	u8   work[48];			//ėp[NGA
} ST_TASK;


//----
typedef struct {
	u16 sx;
	u16 sy;
	u16 tileNo;
} ST_SPR_DATA;


typedef struct {
	u16         cnt;
	ST_SPR_DATA data[SPR_MAX_CNT];
} ST_SPR;


//----
//ėp[NGA̒`iST_TASKworkj
typedef struct {
	s16 cnt[8];
} ST_TASK_WORK_TITLE;


typedef struct {
	s16 cnt[8];
} ST_TASK_WORK_BATTLE;


typedef struct {
	ST_POS pos;				//W
	s16    vx;				//ړ
	s16    vy;
	s16    speed;			//ړx
	s16    rapidCnt;		//A˃JEg
	s16    hp;				//@݂̌̑ϋv
} ST_TASK_WORK_MYSHIP;


typedef struct {
	ST_POS pos;				//W
	s16    vx;				//ړ
	s16    vy;
	u8     angle;			//ړpx
	s16    speed;			//ړx
} ST_TASK_WORK_MYSHOT;


typedef struct {
	ST_POS pos;				//W
	s16    vx;				//ړ
	s16    vy;
	s16    x1;				//Փ˔
	s16    x2;
	s16    y1;
	s16    y2;
	s16    hp;				//ϋv
	s16    cnt[4];			//ėpJE^
} ST_TASK_WORK_ENEMY;

typedef struct{
	bool   isUse;
	ST_POS pos;
	s16    vx;				//ړ
	s16    vy;
	u8     angle;			//ړpx
	s16    speed;			//ړx
} ST_TASK_WORK_BULLET;


//---------------------------------------------------------------------------
IWRAM_CODE void     TaskInit();
IWRAM_CODE ST_TASK* TaskSet(void* pFunc);
IWRAM_CODE void     TaskExec();
IWRAM_CODE void     TaskDel(ST_TASK* p);


//----
IWRAM_CODE void TaskSetTitle();
IWRAM_CODE void TaskActTitle(ST_TASK* p);


//----
IWRAM_CODE void TaskSetBattle();
IWRAM_CODE void TaskActBattle(ST_TASK* p);


//----
IWRAM_CODE void TaskSetMyShip();
IWRAM_CODE void TaskActMyShip(ST_TASK* p);


//----
IWRAM_CODE void TaskSetMyShot(u16 x, u16 y);
IWRAM_CODE void TaskActMyShot(ST_TASK* p);


//----
IWRAM_CODE void TaskSetEnemy1();
IWRAM_CODE void TaskActEnemy1(ST_TASK *p);


//----
IWRAM_CODE void TaskSetEnemy2();
IWRAM_CODE void TaskActEnemy2(ST_TASK *p);


//----
IWRAM_CODE void TaskSetEnemy3();
IWRAM_CODE void TaskActEnemy3(ST_TASK *p);


//----
IWRAM_CODE void TaskSetBullet(u8 x, u8 y, s16 speed, s16 angle, u8 way, u8 vangle);
IWRAM_CODE void TaskActBullet(ST_TASK *p);


//----
IWRAM_CODE void SprInit();
IWRAM_CODE void SprSet(u16 sx, u16 sy, u16 tileNo);
IWRAM_CODE void SprDraw();
IWRAM_CODE u16  SprGetCnt();
IWRAM_CODE bool SprIsOut(u16 x, u16 y);




#ifdef __cplusplus
}
#endif
#endif
